VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsGraphical"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Const IndicatorLeft = 10 ' Relatuve left position of indicator
Private Const IndicatorWidth = 10 ' Width of indicator

Private Type rect
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

' Algorithm
Private menAlgorithm As AlgorithmEnum
Private mstrSortName As String
' Lines array
Private mlngLine() As Long
Private mlngLines As Long
Private mlngLBound As Long
Private mlngUBound As Long
' Operations
Private mtypOp() As OperationType
Private mlngOps As Long
Private mlngCurrentOp As Long
Private mlngComparisons As Long
Private mlngExchanges As Long
' Coordinates
Private mlngLeft As Long
Private mlngTop As Long
Private mlngWidth As Long
Private mlngHeight As Long
Private mrcBars As rect
Private mrcIndicator As rect
' Miscellaneous
Private mobjParent As Object
Private mlngRank As Long
Private mlngTextHeight As Long
Private mblnSelected As Boolean
Private mblnCursor As Long
Private mblnShowResults As Boolean



' METHODS


Public Sub ClearIndicator()
    With mrcIndicator
        If .Top <> 0 And .Bottom <> 0 Then
            mobjParent.Line (.Left, .Top)-(.Right, .Top), vbWhite
            mobjParent.Line (.Left, .Top)-(.Left, .Bottom), vbWhite
            mobjParent.Line (.Left, .Bottom)-(.Right, .Bottom), vbWhite
        End If
        .Top = 0
        .Bottom = 0
    End With
End Sub

Public Sub DefineRegion(plngLeft As Long, plngTop As Long, plngWidth As Long, plngHeight As Long, penOrder As OrderEnum, Optional pblnShowFrame As Boolean = True)
    mlngLeft = plngLeft
    mlngTop = plngTop
    mlngWidth = plngWidth
    mlngHeight = plngHeight
    mlngTextHeight = mobjParent.TextHeight("Qg")
    DrawFrame pblnShowFrame
    ShowName
    InitBars penOrder
End Sub

Public Sub Generate()
    GraphicalSort menAlgorithm, mlngLine, mtypOp, mlngComparisons, mlngExchanges
    mlngOps = mlngComparisons + mlngExchanges
    mlngCurrentOp = 0
End Sub

Public Function HitTest(ByVal X As Long, ByVal Y As Long) As Boolean
    Dim lngRight As Long
    Dim lngBottom As Long
    
    lngRight = mlngLeft + mlngWidth
    lngBottom = mlngTop + mlngHeight
    HitTest = (X >= mlngLeft And X <= lngRight And Y >= mlngTop And Y <= lngBottom)
End Function

Public Sub InitGraph(pfrmParent As Object, penAlgorithm As AlgorithmEnum, Optional pblnShowResults As Boolean = True)
    Set mobjParent = pfrmParent
    Me.Algorithm = penAlgorithm
    mblnShowResults = pblnShowResults
End Sub

Public Sub Iterate()
    If mlngCurrentOp < mlngOps Then
        DrawIndicator
        mlngCurrentOp = mlngCurrentOp + 1
    ElseIf mlngCurrentOp = mlngOps Then
        ClearIndicator
        If mblnShowResults Then ShowResults
    End If
End Sub

Public Sub Shuffle()
    OrderArray mlngLine, oeRandom
    Generate
    DrawBars
End Sub



' PROPERTIES


' Algorithm
Public Property Let Algorithm(penAlgorithm As AlgorithmEnum)
    menAlgorithm = penAlgorithm
    mstrSortName = GetSortName(menAlgorithm)
    If Not (mobjParent Is Nothing) And mblnShowResults Then ShowName
End Property

Public Property Get Algorithm() As AlgorithmEnum
    Algorithm = menAlgorithm
End Property


' Bottom
Public Property Get Bottom() As Long
    Bottom = mlngTop + mlngHeight
End Property


' Comparisons
Public Property Get Comparisons() As Long
    Comparisons = mlngComparisons
End Property


' Cursor
Public Property Let Cursor(pblnCursor As Boolean)
    If mblnCursor <> pblnCursor Then
        mblnCursor = pblnCursor
        DrawCursor
    End If
End Property

Public Property Get Cursor() As Boolean
    Cursor = mblnCursor
End Property


' Exchanges
Public Property Get Exchanges() As Long
    Exchanges = mlngExchanges \ 2
End Property


' Height
Public Property Let Height(plngHeight As Long)
    mlngHeight = plngHeight
End Property

Public Property Get Height() As Long
    Height = mlngHeight
End Property


' Left
Public Property Let Left(plngLeft As Long)
    mlngLeft = plngLeft
End Property

Public Property Get Left() As Long
    Left = mlngLeft
End Property


' LineArray
Public Property Let LineArray(plngLine() As Long)
    mlngLine = plngLine
    mlngLBound = LBound(mlngLine)
    mlngUBound = UBound(mlngLine)
    mlngLines = mlngUBound - mlngLBound + 1
    ShowName
    ClearIndicator
    DrawBars True
End Property

Public Property Get LineArray() As Long()
    LineArray = mlngLine
End Property


' Lines
Public Property Get Lines() As Long
    Lines = mlngLines
End Property


' Operations
Public Property Get Operations() As Long
    Operations = mlngOps
End Property


' Rank
Public Property Let Rank(plngRank As Long)
    mlngRank = plngRank
End Property

Public Property Get Rank() As Long
    Rank = mlngRank
End Property


' Right
Public Property Get Right() As Long
    Right = mlngLeft + mlngWidth
End Property


' Selected
Public Property Let Selected(pblnSelected As Boolean)
    mblnSelected = pblnSelected
    DrawHighlight
End Property

Public Property Get Selected() As Boolean
    Selected = mblnSelected
End Property


' SortName
Public Property Get SortName() As String
    SortName = mstrSortName
End Property


' Top
Public Property Let Top(plngTop As Long)
    mlngTop = plngTop
End Property

Public Property Get Top() As Long
    Top = mlngTop
End Property


' Width
Public Property Let Width(plngWidth As Long)
    mlngWidth = plngWidth
End Property

Public Property Get Width() As Long
    Width = mlngWidth
End Property



' INTERNAL FUNCTIONS


Private Sub Class_Terminate()
    Set mobjParent = Nothing
End Sub

Private Sub DrawCursor()
    Dim lngLeft As Long
    Dim lngTop As Long
    Dim lngRight As Long
    Dim lngBottom As Long
    Dim clrColor As ColorConstants
    
    lngLeft = mlngLeft + 2
    lngTop = mlngTop + 2
    lngRight = mlngLeft + mlngWidth - 2
    lngBottom = mlngTop + mlngHeight - 2
    If mblnCursor Then
        mobjParent.DrawStyle = vbDot
        clrColor = vbBlack
    Else
        clrColor = vbWhite
    End If
    mobjParent.Line (lngLeft, lngTop)-(lngRight, lngTop), clrColor
    mobjParent.Line Step(0, 0)-(lngRight, lngBottom), clrColor
    mobjParent.Line Step(0, 0)-(lngLeft, lngBottom), clrColor
    mobjParent.Line Step(0, 0)-(lngLeft, lngTop), clrColor
    If mblnCursor Then
        mobjParent.DrawStyle = vbSolid
    Else
        DrawBars
    End If
End Sub

Private Sub DrawBars(Optional pblnClear As Boolean = False)
    Dim i As Long
    Dim lngOffset As Long
    Dim lngRight As Long
    Dim lngMaxRight As Long
    
    If mlngLines >= 0 Then
        With mrcBars
            If mblnSelected Then lngMaxRight = .Right - 1 Else lngMaxRight = .Right
            For i = mlngLBound To mlngUBound
                lngOffset = i * 2 + 1 + .Top
                If pblnClear Then mobjParent.Line (.Left, lngOffset - 1)-(lngMaxRight, lngOffset - 1), vbWhite
                lngRight = .Left + mlngLine(i)
                If lngRight > lngMaxRight Then lngRight = lngMaxRight
                mobjParent.Line (.Left, lngOffset)-(lngRight, lngOffset)
                If lngRight < lngMaxRight Then mobjParent.Line (lngRight, lngOffset)-(lngMaxRight, lngOffset), vbWhite
            Next
        End With
    End If
End Sub

Private Sub DrawFrame(pblnShowFrame As Boolean)
    Dim lngRight As Long
    Dim lngBottom As Long
    Dim lngOffset As Long
    
    lngRight = mlngLeft + mlngWidth
    lngBottom = mlngTop + mlngHeight
    lngOffset = Margin * 2
    mobjParent.FillColor = vbWhite
    mobjParent.FillStyle = vbSolid
'    mobjParent.Line (mlngLeft, mlngTop)-(lngRight, lngBottom), vbWhite, BF
    If pblnShowFrame Then
        mobjParent.Line (mlngLeft, mlngTop)-(lngRight, lngBottom), vbApplicationWorkspace, B
    Else
        mobjParent.Line (mlngLeft, mlngTop)-(lngRight, lngBottom), vbWhite, B
    End If
    With mrcBars
        .Left = mlngLeft + BarLeft
        .Top = mlngTop + mlngTextHeight + lngOffset
        .Right = lngRight
        .Bottom = lngBottom - lngOffset
    End With
    With mrcIndicator
        .Left = mlngLeft + IndicatorLeft
        .Right = .Left + IndicatorWidth
    End With
End Sub

Private Sub DrawHighlight()
    Dim lngLeft As Long
    Dim lngTop As Long
    Dim lngRight As Long
    Dim lngBottom As Long
    Dim clrColor As ColorConstants
    
    lngLeft = mlngLeft
    lngTop = mlngTop
    lngRight = mlngLeft + mlngWidth
    lngBottom = mlngTop + mlngHeight
    If mblnSelected Then
        clrColor = vbRed
    Else
        clrColor = vbApplicationWorkspace
    End If
    mobjParent.Line (lngLeft, lngTop)-(lngRight, lngTop), clrColor
    mobjParent.Line Step(0, 0)-(lngRight, lngBottom), clrColor
    mobjParent.Line Step(0, 0)-(lngLeft, lngBottom), clrColor
    mobjParent.Line Step(0, 0)-(lngLeft, lngTop), clrColor
    lngLeft = lngLeft + 1
    lngTop = lngTop + 1
    lngRight = lngRight - 1
    lngBottom = lngBottom - 1
    If Not mblnSelected Then clrColor = vbWhite
    mobjParent.Line (lngLeft, lngTop)-(lngRight, lngTop), clrColor
    mobjParent.Line Step(0, 0)-(lngRight, lngBottom), clrColor
    mobjParent.Line Step(0, 0)-(lngLeft, lngBottom), clrColor
    mobjParent.Line Step(0, 0)-(lngLeft, lngTop), clrColor
    If Not mblnSelected Then DrawBars
End Sub

Private Sub DrawIndicator()
    Dim lng1 As Long
    Dim lng2 As Long
    Dim lngAnchor As Long
    Dim lngOffset As Long
    Dim lngSwap As Long
    Dim lngTop As Long
    Dim lngBottom As Long
    Dim lngMaxLen As Long
    Dim lngRight As Long
    
    ' Determine new indicator
    With mtypOp(mlngCurrentOp)
        lng1 = .Swap1
        lng2 = .Swap2
        lngAnchor = .Anchor
        lngSwap = .Value
        ' Clear old indicator
        If .Operation = opCompare Or .Operation = opOverwrite Then
            With mrcIndicator
                If .Top <> 0 And .Bottom <> 0 Then
                    mobjParent.Line (.Left, .Top)-(.Right, .Top), vbWhite
                    mobjParent.Line (.Left, .Top)-(.Left, .Bottom), vbWhite
                    mobjParent.Line (.Left, .Bottom)-(.Right, .Bottom), vbWhite
                End If
            End With
        End If
    End With
    ' Calculate positions
    With mrcBars
        lngTop = lng1 * 2 + 1 + .Top
        lngBottom = lng2 * 2 + 1 + .Top
        lngMaxLen = .Right - .Left
    End With
    ' Perform operation
    With mrcIndicator
        Select Case mtypOp(mlngCurrentOp).Operation
            Case opCompare
                .Top = lngTop
                .Bottom = lngBottom
                ' Draw indicator
                mobjParent.Line (.Left, .Top)-(.Right, .Top), vbRed
                mobjParent.Line (.Left, .Top)-(.Left, .Bottom), vbRed
                mobjParent.Line (.Left, .Bottom)-(.Right, .Bottom), vbRed
            Case opExchange
                lngSwap = mlngLine(lng1)
                mlngLine(lng1) = mlngLine(lng2)
                mlngLine(lng2) = lngSwap
                With mrcBars
                    ' Top line
                    lngRight = .Left + mlngLine(lng1)
                    If lngRight > .Right Then lngRight = .Right
                    mobjParent.Line (.Left, lngTop)-(lngRight, lngTop)
                    If lngRight < .Right Then mobjParent.Line (lngRight, lngTop)-(.Right, lngTop), vbWhite
                    ' Bottom line
                    lngRight = .Left + mlngLine(lng2)
                    If lngRight > .Right Then lngRight = .Right
                    mobjParent.Line (.Left, lngBottom)-(lngRight, lngBottom)
                    If lngRight < .Right Then mobjParent.Line (lngRight, lngBottom)-(.Right, lngBottom), vbWhite
                End With
            Case opMerge
                ' Update indicator
                If .Top <> lngTop Or .Bottom <> lngBottom Then
                    ' Clear old indicator
                    If .Top <> 0 And .Bottom <> 0 Then
                        mobjParent.Line (.Left, .Top)-(.Right, .Top), vbWhite
                        mobjParent.Line (.Left, .Top)-(.Left, .Bottom), vbWhite
                        mobjParent.Line (.Left, .Bottom)-(.Right, .Bottom), vbWhite
                    End If
                    .Top = lngTop
                    .Bottom = lngBottom
                    ' Draw indicator
                    mobjParent.Line (.Left, .Top)-(.Right, .Top), vbRed
                    mobjParent.Line (.Left, .Top)-(.Left, .Bottom), vbRed
                    mobjParent.Line (.Left, .Bottom)-(.Right, .Bottom), vbRed
                End If
                ' Showed merged value
                mlngLine(lngAnchor) = mtypOp(mlngCurrentOp).Value
                With mrcBars
                    lngOffset = lngAnchor * 2 + 1 + .Top
                    lngRight = .Left + mlngLine(lngAnchor)
                    If lngRight > .Right Then lngRight = .Right
                    mobjParent.Line (.Left, lngOffset)-(lngRight, lngOffset)
                    If lngRight < .Right Then mobjParent.Line (lngRight, lngOffset)-(.Right, lngOffset), vbWhite
                End With
            Case opOverwrite
                .Top = lng2 * 2 + 1 + mrcBars.Top
                .Bottom = lngAnchor * 2 + 1 + mrcBars.Top
                ' Draw indicator
                mobjParent.Line (.Left, .Top)-(.Right, .Top), vbRed
                mobjParent.Line (.Left, .Top)-(.Left, .Bottom), vbRed
                mobjParent.Line (.Left, .Bottom)-(.Right, .Bottom), vbRed
                lngSwap = mlngLine(lng1)
                mlngLine(lng1) = mlngLine(lng2)
                mlngLine(lng2) = lngSwap
                With mrcBars
                    ' First line
                    lngOffset = lng1 * 2 + 1 + .Top
                    lngRight = .Left + mlngLine(lng1)
                    If lngRight > .Right Then lngRight = .Right
                    mobjParent.Line (.Left, lngOffset)-(lngRight, lngOffset)
                    If lngRight < .Right Then mobjParent.Line (lngRight, lngOffset)-(.Right, lngOffset), vbWhite
                    ' Second line
                    lngOffset = lng2 * 2 + 1 + .Top
                    lngRight = .Left + mlngLine(lng2)
                    If lngRight > .Right Then lngRight = .Right
                    mobjParent.Line (.Left, lngOffset)-(lngRight, lngOffset)
                    If lngRight < .Right Then mobjParent.Line (lngRight, lngOffset)-(.Right, lngOffset), vbWhite
                End With
        End Select
    End With
End Sub

Private Sub InitBars(penOrder As OrderEnum)
    Dim lngWidth As Long
    Dim lngHeight As Long
    Dim lngGrowth As Long
    Dim i As Long
    
    With mrcBars
        lngWidth = .Right - .Left
        lngHeight = .Bottom - .Top
        If lngHeight > 0 Then
            mlngLines = lngHeight \ 2
            If lngWidth / lngHeight < 0.8 Then lngGrowth = 1 Else lngGrowth = 2
        Else
            mlngLines = 0
        End If
        If mlngLines >= 0 Then
            ReDim mlngLine(mlngLines)
            mlngLBound = LBound(mlngLine)
            mlngUBound = UBound(mlngLine)
            For i = mlngLBound To mlngUBound
                mlngLine(i) = i * lngGrowth + 1
            Next
            If penOrder <> oeAscending Then OrderArray mlngLine, penOrder
        End If
    End With
    DrawBars
End Sub

Private Sub ShowName(Optional pblnBold As Boolean = False)
    Dim lngTextWidth As Long
    Dim lngTextHeight As Long
    
    With mobjParent
        .FontBold = pblnBold
        lngTextWidth = .TextWidth(mstrSortName)
        lngTextHeight = .TextHeight(mstrSortName)
    End With
    If mblnSelected Then
        mobjParent.Line (mlngLeft + 2, mlngTop + 2)-(mlngLeft + mlngWidth - 2, mlngTop + lngTextHeight + Margin), vbWhite, BF
    Else
        mobjParent.Line (mlngLeft + 1, mlngTop + 1)-(mlngLeft + mlngWidth - 1, mlngTop + lngTextHeight + Margin), vbWhite, BF
    End If
    ShowText mstrSortName, mlngLeft + (mlngWidth - lngTextWidth - Margin) \ 2, mlngTop + Margin, pblnBold
End Sub

Public Sub ShowResults()
    Dim lngLeft As Long
    Dim lngTop As Long
    Dim lngRight As Long
    Dim lngBottom As Long
    Dim lngWidth As Long
    Dim lngHeight As Long
    Dim strDisplay As String
    
    ShowName True
    With mobjParent
        .FontBold = True
        lngWidth = .TextWidth(Format(mlngOps, "#,##0"))
        .FontBold = False
        lngWidth = lngWidth + .TextWidth("Comp: ")
        lngHeight = .TextHeight("Comp: ")
    End With
    lngRight = mlngLeft + mlngWidth - Margin
    lngLeft = lngRight - lngWidth - Margin
    lngTop = mlngTop + lngHeight * 2 + Margin * 2
    lngBottom = lngTop + lngHeight * 4
    If lngLeft > mlngLeft And lngBottom < mlngTop + mlngHeight Then
        ' Clear text area
        mobjParent.Line (lngLeft, lngTop)-(lngRight, lngBottom), vbWhite, BF
        ' Rank
        strDisplay = "#" & mlngRank
        ShowText "Rank:", lngLeft, lngTop, False
        mobjParent.FontBold = True
        ShowText strDisplay, lngRight - mobjParent.TextWidth(strDisplay) - Margin, lngTop, True
        ' Comparisons
        lngTop = lngTop + lngHeight
        strDisplay = Format(mlngComparisons, "#,##0")
        ShowText "Comp:", lngLeft, lngTop, False
        ShowText strDisplay, lngRight - mobjParent.TextWidth(strDisplay) - Margin, lngTop, False
        ' Exchanges
        lngTop = lngTop + lngHeight
        strDisplay = Format(mlngExchanges \ 2, "#,##0")
        ShowText "Exch:", lngLeft, lngTop, False
        ShowText strDisplay, lngRight - mobjParent.TextWidth(strDisplay) - Margin, lngTop, False
        ' Time
        lngTop = lngTop + lngHeight
        strDisplay = Format(mlngOps, "#,##0")
        ShowText "Time:", lngLeft, lngTop, False
        mobjParent.FontBold = True
        ShowText strDisplay, lngRight - mobjParent.TextWidth(strDisplay) - Margin, lngTop, True
    End If
End Sub

Private Sub ShowText(pstrText As String, plngLeft As Long, plngTop As Long, pblnBold As Boolean)
    With mobjParent
        If .FontBold <> pblnBold Then .FontBold = pblnBold
        .CurrentX = plngLeft
        .CurrentY = plngTop
        mobjParent.Print pstrText
        If .FontBold Then .FontBold = False
    End With
End Sub

