VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsSettings"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Property variables
Private mblnLargeFonts As Boolean
Private mblnLargeIcons As Boolean
Private mblnPersistSettings As Boolean
Private mblnShowWelcome As Boolean



' PROPERTIES


' DocsPath
Public Property Get DocsPath() As String
    With xp.Folder
        If Left(.Application, Len(.UserDocs)) = .UserDocs Then
            DocsPath = .Application
        Else
            DocsPath = .UserDocs
        End If
    End With
End Property


' Large Fonts
Public Property Let LargeFonts(pblnLargeFonts As Boolean)
    Dim frm As Form
    Dim blnChanged As Boolean
    
    blnChanged = (mblnLargeFonts <> pblnLargeFonts)
    mblnLargeFonts = pblnLargeFonts
    If mblnPersistSettings Then xp.Registry.WriteBoolean RegistryKey, "LargeFonts", mblnLargeFonts
    If blnChanged Then
        FormLayout frmOptions
        frmMain.Redraw
    End If
End Property

Public Property Get LargeFonts() As Boolean
    LargeFonts = mblnLargeFonts
End Property


' LargeIcons
Public Property Let LargeIcons(pblnLargeIcons As Boolean)
    Dim blnChanged As Boolean
    
    blnChanged = (mblnLargeIcons <> pblnLargeIcons)
    mblnLargeIcons = pblnLargeIcons
    If mblnPersistSettings Then xp.Registry.WriteBoolean RegistryKey, "LargeIcons", mblnLargeIcons
    If blnChanged Then
        ToolbarIconSize frmMain
        DoEvents
        frmMain.Redraw
    End If
End Property

Public Property Get LargeIcons() As Boolean
    LargeIcons = mblnLargeIcons
End Property


' PersistSettings
Public Property Let PersistSettings(pblnPersistSettings As Boolean)
    mblnPersistSettings = pblnPersistSettings
    If mblnPersistSettings Then
        xp.Registry.CreateKey RegistryKey
        LargeFonts = mblnLargeFonts
        LargeIcons = mblnLargeIcons
        ShowWelcome = mblnShowWelcome
    Else
        With xp.Registry
            .DeleteKey RegistryKey
            If Not .HasSubKeys(ParentKey) Then .DeleteKey ParentKey
        End With
    End If
End Property

Public Property Get PersistSettings() As Boolean
    PersistSettings = mblnPersistSettings
End Property


' ShowWelcome
Public Property Let ShowWelcome(pblnShowWelcome As Boolean)
    mblnShowWelcome = pblnShowWelcome
    If mblnPersistSettings Then xp.Registry.WriteBoolean RegistryKey, "ShowWelcome", mblnShowWelcome
End Property

Public Property Get ShowWelcome() As Boolean
    ShowWelcome = mblnShowWelcome
End Property


' TempPath
Public Property Get TempPath() As String
    TempPath = xp.Folder.UserAppData & "\" & CompanyName & "\" & AppName
End Property



' INTERNAL FUNCTIONS


Private Sub Class_Initialize()
    mblnPersistSettings = xp.Registry.KeyExists(RegistryKey)
    mblnLargeFonts = xp.Registry.ReadBoolean(RegistryKey, "LargeFonts", False)
    mblnLargeIcons = xp.Registry.ReadBoolean(RegistryKey, "LargeIcons", (Screen.Width \ Screen.TwipsPerPixelX > 1024))
    mblnShowWelcome = xp.Registry.ReadBoolean(RegistryKey, "ShowWelcome", True)
End Sub
