VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsStatusbar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Const Margin = 7
Private Const SliderText = "                              "
' General
Private mpicParent As PictureBox
Private mstrCaption As String
Private mstrDefaultCaption As String
Private mstrSimpleText As String
Private mblnMaximized As Boolean
Private mvarTag As Variant
Private mblnLoaded As Boolean
' Slider
Private mlngSlider As Long
Private mblnHot As Boolean
' Progressbar
Private mlngProgress As Long
Private mlngProgressMax As Long
Private mlngBlocks As Long
Private mlngNextBlock As Long
Private mlngNextCutoff As Long
' Coordinates / dimensions
Private mlngOffsetX As Long
Private mlngOffsetY As Long
Private mlngLeft As Long
Private mlngTop As Long
Private mlngRight As Long
Private mlngBottom As Long
Private mlngLineTop As Long
Private mlngLineBottom As Long
Private mlngTextLeft As Long
Private mlngTextTop As Long
Private mlngTextRight As Long
Private mlngTextHeight As Long
Private mlngSliderLeft As Long
Private mlngSliderRight As Long
Private mlngProgressLeft As Long
Private mlngProgressTop As Long
Private mlngProgressBottom As Long
Private mlngProgressSide As Long
Private mlngProgressLastWidth As Long



' METHODS


Public Sub Init(pobjParent As Object, pstrCaption As String, plngSlider As Long, Optional pblnResize As Boolean)
    Set mpicParent = pobjParent
    With mpicParent
        If .Parent.ScaleMode = vbPixels Then
            mlngOffsetX = 1
            mlngOffsetY = 1
        Else
            mlngOffsetX = Screen.TwipsPerPixelX
            mlngOffsetY = Screen.TwipsPerPixelY
        End If
        .AutoRedraw = True
        Set .Font = .Parent.Font
        .ScaleMode = vbPixels
        .BorderStyle = vbBSNone
        .BackColor = vbButtonFace
        .Visible = True
    End With
    mstrCaption = pstrCaption
    mstrDefaultCaption = pstrCaption
    mlngSlider = plngSlider
    mblnLoaded = True
    If pblnResize Then Resize
End Sub

Public Function IsHot(ByVal plngX As Long, ByVal plngY As Long, pblnHot As Boolean) As Boolean
    If Not pblnHot Then pblnHot = (plngX >= mlngSliderLeft And plngX <= mlngSliderRight And plngY >= mlngLineTop And plngY <= mlngLineBottom)
    If mblnHot <> pblnHot Then
        mblnHot = pblnHot
        If mblnHot Then mpicParent.MousePointer = vbCustom Else mpicParent.MousePointer = vbNormal
    End If
    IsHot = mblnHot
End Function

Public Function HotSlider(ByVal X As Long) As Long
    Dim lngLeft As Long
    Dim lngRight As Long
    Dim lngValue As Long
    
    lngLeft = mlngSliderLeft + Margin
    lngRight = mlngSliderRight - Margin
    If X < lngLeft Then
        lngValue = 1
    ElseIf X > lngRight Then
        lngValue = 100
    Else
        lngValue = 100 * (X - lngLeft) \ (lngRight - lngLeft)
        Select Case lngValue
            Case Is < 1: lngValue = 1
            Case Is > 100: lngValue = 100
        End Select
    End If
    If mlngSlider <> lngValue Then
        EraseSlider True
        mlngSlider = lngValue
        DrawSlider X
    End If
    HotSlider = mlngSlider
End Function

Public Sub ProgressInit(plngMax As Long, Optional plngValue As Long)
    Dim lngRemaining As Long
    
    mpicParent.Line (mlngProgressLeft + 1, mlngLineTop + 1)-(mlngRight - 1, mlngLineBottom - 1), vbButtonFace, BF
    mlngProgress = plngValue
    If plngMax < 0 Then mlngProgressMax = 0 Else mlngProgressMax = plngMax
    mlngProgressSide = mpicParent.TextWidth("o")
    If (mlngLineBottom - mlngLineTop - mlngProgressSide) Mod 2 <> 0 Then mlngProgressSide = mlngProgressSide - 1
    If mlngProgressSide <= 0 Then mlngProgressSide = 0
    mlngProgressTop = mlngLineTop + (mlngLineBottom - mlngLineTop - mlngProgressSide) \ 2
    mlngProgressBottom = mlngProgressTop + mlngProgressSide
    mlngBlocks = (mlngRight - mlngProgressLeft - 2) \ (mlngProgressSide + 2)
    lngRemaining = mlngRight - mlngProgressLeft - 2 - (mlngProgressSide + 2) * mlngBlocks
    Select Case lngRemaining
        Case 0: mlngProgressLastWidth = mlngProgressSide - 2
        Case 1 To 3: mlngProgressLastWidth = mlngProgressSide + lngRemaining - 2
        Case Else
            mlngBlocks = mlngBlocks + 1
            mlngProgressLastWidth = lngRemaining - 4
    End Select
    ' Convert to zero-based
    mlngBlocks = mlngBlocks - 1
    mlngNextBlock = 0
    mlngNextCutoff = 1
    DrawProgress
End Sub

Public Sub ProgressIncrement()
    If mlngProgress < mlngProgressMax Then mlngProgress = mlngProgress + 1
    DrawProgress
End Sub

Public Sub ProgressRemove()
    mlngProgress = 0
    mlngProgressMax = 0
    mpicParent.Line (mlngProgressLeft + 1, mlngLineTop + 1)-(mlngRight - 1, mlngLineBottom - 1), vbButtonFace, BF
End Sub

Public Sub Resize()
    If mblnLoaded Then
        CalculateDimensions
        Redraw
    End If
End Sub



' PROPERTIES


' Caption
Public Property Let Caption(pstrCaption As String)
    mstrCaption = pstrCaption
    CalculateDimensions
    Redraw
End Property

Public Property Get Caption() As String
    Caption = mstrCaption
End Property


' Default Caption
Public Property Get DefaultCaption() As String
    DefaultCaption = mstrDefaultCaption
End Property


' Simple Text
Public Property Let SimpleText(pstrSimpleText As String)
    mstrSimpleText = pstrSimpleText
    If Len(mstrSimpleText) = 0 Then
        Redraw
    Else
        mpicParent.Cls
        mpicParent.Line (mlngLeft, mlngTop)-(mlngRight, mlngLineBottom), vbButtonFace, BF
        mpicParent.Line (mlngLeft, mlngLineTop)-(mlngRight, mlngLineTop), vbButtonShadow
        mpicParent.Line (mlngLeft, mlngLineTop)-(mlngLeft, mlngLineBottom), vbButtonShadow
        mpicParent.Line (mlngRight, mlngLineTop)-(mlngRight, mlngLineBottom), vbWhite
        If Not mblnMaximized Then mpicParent.Line (mlngLeft, mlngLineBottom)-(mlngRight + 1, mlngLineBottom), vbWhite
        mpicParent.CurrentX = mlngTextLeft
        mpicParent.CurrentY = mlngTextTop
        mpicParent.Print mstrSimpleText
    End If
End Property

Public Property Get SimpleText() As String
    SimpleText = mstrSimpleText
End Property


' Slider
Public Property Let Slider(ByVal plngValue As Long)
    Select Case plngValue
        Case Is < 1: plngValue = 1
        Case Is > 100: plngValue = 100
    End Select
    If mlngSlider <> plngValue Then
        EraseSlider True
        mlngSlider = plngValue
        DrawSlider
    End If
End Property

Public Property Get Slider() As Long
    Slider = mlngSlider
End Property


' Tag
Public Property Let Tag(pvarTag As Variant)
    mvarTag = pvarTag
End Property

Public Property Get Tag() As Variant
    Tag = mvarTag
End Property


' Top
Public Property Get Top() As Long
    Top = mlngTop
End Property



' INTERNAL FUNCTIONS


Private Sub Class_Terminate()
    Set mpicParent = Nothing
End Sub

Private Sub CalculateDimensions()
    Dim lngOffset As Long
    Dim lngTop As Long
    Dim lngWidth As Long
    Dim lngHeight As Long
    
    mblnMaximized = (mpicParent.Parent.WindowState = vbMaximized)
    If Not mblnMaximized Then lngOffset = 1
    With mpicParent
        mlngTextHeight = mpicParent.TextHeight("Q")
        With .Parent
            lngHeight = (mlngTextHeight + 4) * mlngOffsetY
            lngTop = .ScaleHeight - lngHeight
            lngWidth = .ScaleWidth
        End With
        .Move 0, lngTop, lngWidth, lngHeight
        mlngLeft = 0
        mlngTop = 0
        mlngRight = .ScaleWidth - 1
        mlngBottom = .ScaleHeight
        mlngLineBottom = mlngBottom - lngOffset
    End With
    mlngLeft = 0
    mlngTextLeft = mlngLeft + Margin
    mlngTextRight = mlngTextLeft + mpicParent.TextWidth(mstrCaption) + Margin
    mlngTextTop = mlngTop + 3
    mlngLineTop = mlngTop + 2
    mlngSliderLeft = mlngTextRight + 3
    mlngSliderRight = mlngSliderLeft + mpicParent.TextWidth(SliderText)
    mlngProgressLeft = mlngSliderRight + 3
    
    
'    mlngTextHeight = mpicParent.TextHeight("Q")
'    mlngLeft = 0
'    mlngRight = mpicParent.ScaleWidth - 1
'    mlngLineBottom = mpicParent.ScaleHeight - lngOffset
'    mlngBottom = mlngLineBottom - 1
'    mlngTop = mlngLineBottom - mlngTextHeight - 4
'    mlngTextLeft = mlngLeft + Margin
'    mlngTextRight = mlngTextLeft + mpicParent.TextWidth(mstrCaption) + Margin
'    mlngTextTop = mlngTop + 3
'    mlngLineTop = mlngTop + 2
'    mlngSliderLeft = mlngTextRight + 3
'    mlngSliderRight = mlngSliderLeft + mpicParent.TextWidth(SliderText)
'    mlngProgressLeft = mlngSliderRight + 3
End Sub

Private Sub DrawProgress()
    Dim lngLeft As Long
    
    If mlngProgress >= mlngNextCutoff Then
        lngLeft = mlngProgressLeft + 3 + mlngNextBlock * (mlngProgressSide + 2)
        If mlngNextBlock = mlngBlocks Then
            mpicParent.Line (lngLeft, mlngProgressTop)-(lngLeft + mlngProgressLastWidth, mlngProgressBottom), vbHighlight, BF
        Else
            mpicParent.Line (lngLeft, mlngProgressTop)-(lngLeft + mlngProgressSide - 1, mlngProgressBottom), vbHighlight, BF
        End If
        mlngNextBlock = mlngNextBlock + 1
        mlngNextCutoff = mlngNextBlock / mlngBlocks * mlngProgressMax
    End If
End Sub

Private Sub DrawSlider(Optional ByVal plngX As Long)
    Dim lngTop As Long

    If plngX = 0 Then
        Select Case mlngSlider
            Case 1: plngX = mlngSliderLeft + Margin
            Case 100: plngX = mlngSliderRight - Margin
            Case Else: plngX = (mlngSliderRight - mlngSliderLeft - 14) * mlngSlider / 100 + mlngSliderLeft + Margin
        End Select
    Else
        Select Case plngX
            Case Is < mlngSliderLeft + Margin: plngX = mlngSliderLeft + Margin
            Case Is > mlngSliderRight - Margin: plngX = mlngSliderRight - Margin
        End Select
    End If
    lngTop = mlngLineTop + (mlngLineBottom - mlngLineTop) \ 2 - 2
    Select Case mlngTextHeight
        Case Is > 28
            plngX = plngX - 5
            lngTop = lngTop - 8
            mpicParent.Line (plngX, lngTop)-(plngX + 11, lngTop), vbWhite
            mpicParent.Line (plngX, lngTop)-(plngX, lngTop + 15), vbWhite
            mpicParent.Line (plngX, lngTop + 15)-(plngX + 5, lngTop + 20), vbWhite
            mpicParent.Line (plngX + 1, lngTop + 1)-(plngX + 8, lngTop + 14), vbButtonFace, BF
            plngX = plngX + 9
            mpicParent.Line (plngX, lngTop + 1)-(plngX, lngTop + 16), vbButtonShadow
            mpicParent.Line (plngX - 1, lngTop + 16)-(plngX - 5, lngTop + 20), vbButtonShadow
            plngX = plngX + 1
            mpicParent.Line (plngX, lngTop)-(plngX, lngTop + 16), vbBlack
            mpicParent.Line (plngX - 1, lngTop + 16)-(plngX - 6, lngTop + 21), vbBlack
        Case 25 To 28
            plngX = plngX - 4
            lngTop = lngTop - 6
            mpicParent.Line (plngX, lngTop)-(plngX + 8, lngTop), vbWhite
            mpicParent.Line (plngX, lngTop)-(plngX, lngTop + 13), vbWhite
            mpicParent.Line (plngX, lngTop + 12)-(plngX + 4, lngTop + 16), vbWhite
            mpicParent.Line (plngX + 1, lngTop + 1)-(plngX + 6, lngTop + 12), vbButtonFace, BF
            plngX = plngX + 7
            mpicParent.Line (plngX, lngTop + 1)-(plngX, lngTop + 13), vbButtonShadow
            mpicParent.Line (plngX - 1, lngTop + 13)-(plngX - 4, lngTop + 16), vbButtonShadow
            plngX = plngX + 1
            mpicParent.Line (plngX, lngTop)-(plngX, lngTop + 13), vbBlack
            mpicParent.Line (plngX - 1, lngTop + 13)-(plngX - 5, lngTop + 17), vbBlack
        Case 20 To 24
            plngX = plngX - 3
            lngTop = lngTop - 5
            mpicParent.Line (plngX, lngTop)-(plngX + 6, lngTop), vbWhite
            mpicParent.Line (plngX, lngTop)-(plngX, lngTop + 11), vbWhite
            mpicParent.Line (plngX, lngTop + 10)-(plngX + 3, lngTop + 13), vbWhite
            mpicParent.Line (plngX + 1, lngTop + 1)-(plngX + 4, lngTop + 10), vbButtonFace, BF
            plngX = plngX + 5
            mpicParent.Line (plngX, lngTop + 1)-(plngX, lngTop + 11), vbButtonShadow
            mpicParent.Line (plngX - 1, lngTop + 11)-(plngX - 3, lngTop + 13), vbButtonShadow
            plngX = plngX + 1
            mpicParent.Line (plngX, lngTop)-(plngX, lngTop + 11), vbBlack
            mpicParent.Line (plngX - 1, lngTop + 11)-(plngX - 4, lngTop + 14), vbBlack
        Case 15 To 19
            plngX = plngX - 3
            lngTop = lngTop - 3
            mpicParent.Line (plngX, lngTop)-(plngX + 6, lngTop), vbWhite
            mpicParent.Line (plngX, lngTop)-(plngX, lngTop + 9), vbWhite
            mpicParent.Line (plngX, lngTop + 8)-(plngX + 3, lngTop + 11), vbWhite
            mpicParent.Line (plngX + 1, lngTop + 1)-(plngX + 4, lngTop + 8), vbButtonFace, BF
            plngX = plngX + 5
            mpicParent.Line (plngX, lngTop + 1)-(plngX, lngTop + 9), vbButtonShadow
            mpicParent.Line (plngX - 1, lngTop + 9)-(plngX - 3, lngTop + 11), vbButtonShadow
            plngX = plngX + 1
            mpicParent.Line (plngX, lngTop)-(plngX, lngTop + 9), vbBlack
            mpicParent.Line (plngX - 1, lngTop + 9)-(plngX - 4, lngTop + 12), vbBlack
        Case 11 To 14
            plngX = plngX - 2
            lngTop = lngTop - 1
            mpicParent.Line (plngX, lngTop)-(plngX + 5, lngTop), vbWhite
            mpicParent.Line (plngX, lngTop)-(plngX, lngTop + 6), vbWhite
            plngX = plngX + 1
            mpicParent.Line (plngX, lngTop + 1)-(plngX + 1, lngTop + 4), vbButtonFace, BF
            mpicParent.PSet (plngX, lngTop + 6), vbWhite
            plngX = plngX + 1
            mpicParent.PSet (plngX, lngTop + 6), vbButtonShadow
            mpicParent.PSet (plngX, lngTop + 7), vbBlack
            plngX = plngX + 1
            mpicParent.Line (plngX, lngTop + 1)-(plngX, lngTop + 6), vbButtonShadow
            mpicParent.PSet (plngX, lngTop + 6), vbBlack
            plngX = plngX + 1
            mpicParent.Line (plngX, lngTop)-(plngX, lngTop + 6), vbBlack
        Case 7 To 10
            plngX = plngX - 1
            mpicParent.Line (plngX, lngTop)-(plngX, lngTop + 5), vbWhite
            plngX = plngX + 1
            mpicParent.PSet (plngX, lngTop), vbWhite
            mpicParent.Line (plngX, lngTop + 1)-(plngX, lngTop + 4), vbButtonFace
            mpicParent.PSet (plngX, lngTop + 4), vbButtonShadow
            mpicParent.PSet (plngX, lngTop + 5), vbBlack
            plngX = plngX + 1
            mpicParent.Line (plngX, lngTop)-(plngX, lngTop + 5), vbBlack
        Case 1 To 6
            plngX = plngX - 1
            mpicParent.Line (plngX, lngTop)-(plngX, lngTop + 4), vbWhite
            plngX = plngX + 1
            mpicParent.PSet (plngX, lngTop), vbWhite
            mpicParent.Line (plngX, lngTop + 1)-(plngX, lngTop + 3), vbButtonFace
            mpicParent.PSet (plngX, lngTop + 3), vbButtonShadow
            If mlngTextHeight > 3 Then mpicParent.PSet (plngX, lngTop + 4), vbBlack
            plngX = plngX + 1
            mpicParent.Line (plngX, lngTop)-(plngX, lngTop + 4), vbBlack
        Case Else
            MsgBox mlngTextHeight
    End Select
End Sub

Private Sub EraseSlider(pblnClearArea As Boolean)
    Dim lngLeft As Long
    Dim lngTop As Long
    Dim lngRight As Long
    Dim lngX As Long
    
    lngLeft = mlngSliderLeft + Margin
    lngTop = mlngLineTop + (mlngLineBottom - mlngLineTop) \ 2 - 2
    lngRight = mlngSliderRight - Margin
    If pblnClearArea Then mpicParent.Line (mlngSliderLeft + 1, mlngLineTop + 1)-(mlngSliderRight - 1, mlngLineBottom - 1), vbButtonFace, BF
    mpicParent.Line (lngLeft, lngTop + 2)-(lngLeft, lngTop), vbButtonShadow
    mpicParent.Line (lngLeft, lngTop)-(lngRight, lngTop), vbButtonShadow
    lngLeft = lngLeft + 1
    lngTop = lngTop + 1
    mpicParent.Line (lngLeft, lngTop)-(lngRight - 1, lngTop), vbBlack
    lngTop = lngTop + 2
    lngLeft = lngLeft - 1
    mpicParent.Line (lngLeft, lngTop)-(lngRight, lngTop), vbWhite
    mpicParent.Line (lngRight, lngTop - 3)-(lngRight, lngTop + 1), vbWhite
End Sub

Private Sub Redraw()
    Dim lngLeft As Long
    Dim lngTop As Long
    Dim lngRight As Long
    Dim lngWidth As Long
    Dim lngHeight As Long
    
    mpicParent.Cls

    mpicParent.Line (mlngLeft, mlngTop)-(mlngRight, mlngLineBottom), vbButtonFace, BF
    
    mpicParent.Line (mlngLeft, mlngLineTop)-(mlngTextRight, mlngLineTop), vbButtonShadow
    mpicParent.Line (mlngSliderLeft, mlngLineTop)-(mlngSliderRight, mlngLineTop), vbButtonShadow
    mpicParent.Line (mlngProgressLeft, mlngLineTop)-(mlngRight, mlngLineTop), vbButtonShadow

    mpicParent.Line (mlngLeft, mlngLineTop)-(mlngLeft, mlngLineBottom), vbButtonShadow
    mpicParent.Line (mlngSliderLeft, mlngLineTop)-(mlngSliderLeft, mlngLineBottom), vbButtonShadow
    mpicParent.Line (mlngProgressLeft, mlngLineTop)-(mlngProgressLeft, mlngLineBottom), vbButtonShadow

    mpicParent.Line (mlngTextRight, mlngLineTop)-(mlngTextRight, mlngLineBottom), vbWhite
    mpicParent.Line (mlngSliderRight, mlngLineTop)-(mlngSliderRight, mlngLineBottom), vbWhite
    mpicParent.Line (mlngRight, mlngLineTop)-(mlngRight, mlngLineBottom), vbWhite
    
    mpicParent.CurrentX = mlngTextLeft
    mpicParent.CurrentY = mlngTextTop
    mpicParent.Print mstrCaption
    
    EraseSlider False
    DrawSlider
    
    If Not mblnMaximized Then
        mpicParent.Line (mlngLeft, mlngLineBottom)-(mlngTextRight + 1, mlngLineBottom), vbWhite
        mpicParent.Line (mlngSliderLeft, mlngLineBottom)-(mlngSliderRight + 1, mlngLineBottom), vbWhite
        mpicParent.Line (mlngProgressLeft, mlngLineBottom)-(mlngRight + 1, mlngLineBottom), vbWhite
    End If
End Sub

