VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsWindowsXP"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Member0" ,"Drive"
Attribute VB_Ext_KEY = "Member1" ,"File"
Attribute VB_Ext_KEY = "Member2" ,"Folder"
Attribute VB_Ext_KEY = "Member3" ,"Mouse"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Attribute VB_Ext_KEY = "Member4" ,"Registry"
Option Explicit

' Enumerations
Public Enum MouseStateEnum
    msNormal = 1
    msWait = 2
    msSystemWait = 3
    msHidden = 4
End Enum

Private Enum FlagsEnum
    feOpen
    feSaveAs
End Enum

' Property variables
Private menMouse As MouseStateEnum

' Variables
Private mlngLockCount As Long

' Child classes
Private mclsDrive As clsDrive
Private mclsFile As clsFile
Private mclsFolder As clsFolder
Private mclsRegistry As clsRegistry

' Type declarations for API calls
Private Type rect
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Private Type LUID
   LowPart As Long
   HighPart As Long
End Type

Private Type TOKEN_PRIVILEGES
    PrivilegeCount As Long
    LuidUDT As LUID
   Attributes As Long
End Type

Private Type OPENFILENAME
    lStructSize As Long
    hwndOwner As Long
    hInstance As Long
    lpstrFilter As String
    lpstrCustomFilter As String
    nMaxCustFilter As Long
    nFilterIndex As Long
    lpstrFile As String
    nMaxFile As Long
    lpstrFileTitle As String
    nMaxFileTitle As Long
    lpstrInitialDir As String
    lpstrTitle As String
    Flags As Long
    nFileOffset As Integer
    nFileExtension As Integer
    lpstrDefExt As String
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type

' API
Private Declare Function AdjustTokenPrivileges Lib "advapi32" (ByVal TokenHandle As Long, ByVal DisableAllPrivileges As Long, NewState As TOKEN_PRIVILEGES, ByVal BufferLength As Long, PreviousState As Any, ReturnLength As Any) As Long
Private Declare Function ExitWindowsEx Lib "user32" (ByVal dwOptions As Long, ByVal dwReserved As Long) As Long
Private Declare Function GetCurrentProcess Lib "kernel32" () As Long
Private Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long
Private Declare Function GetSaveFileName Lib "comdlg32.dll" Alias "GetSaveFileNameA" (pOpenfilename As OPENFILENAME) As Long
Private Declare Function GetUserName Lib "advapi32.dll" Alias "GetUserNameA" (ByVal lpBuffer As String, nSize As Long) As Long
Private Declare Function GetVersion Lib "kernel32" () As Long
Private Declare Function LockWindowUpdate Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function LookupPrivilegeValue Lib "advapi32" Alias "LookupPrivilegeValueA" (ByVal lpSystemName As String, ByVal lpName As String, lpLuid As LUID) As Long
Private Declare Function OleTranslateColor Lib "oleaut32.dll" (ByVal ColorIn As Long, ByVal hPal As Long, ByRef RGBColorOut As Long) As Long
Private Declare Function OpenProcessToken Lib "advapi32" (ByVal ProcessHandle As Long, ByVal DesiredAccess As Long, TokenHandle As Long) As Long
Private Declare Function SetCursorPos Lib "user32" (ByVal X As Long, ByVal Y As Long) As Long
Private Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
Private Declare Sub SHChangeNotify Lib "shell32.dll" (ByVal wEventId As Long, ByVal uFlags As Long, dwItem1 As Any, dwItem2 As Any)
Private Declare Sub SHEmptyRecycleBin Lib "shell32.dll" Alias "SHEmptyRecycleBinA" (ByVal hwnd As Long, ByVal pszRootPath As String, ByVal dwFlags As Long)
Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpszOp As String, ByVal lpszFile As String, ByVal lpszParams As String, ByVal lpszDir As String, ByVal FsShowCmd As Long) As Long
Private Declare Function ShowCursor Lib "user32" (ByVal bShow As Long) As Long
Private Declare Function SystemParametersInfo Lib "user32" Alias "SystemParametersInfoA" (ByVal uAction As Long, ByVal uParam As Long, lpvParam As Any, ByVal fuWinIni As Long) As Long



' METHODS


' Force Windows to refresh file associations
Public Sub AssociateIcon()
    Const SHCNE_ASSOCCHANGED = &H8000000
    Const SHCNF_IDLIST = 0
    
    SHChangeNotify SHCNE_ASSOCCHANGED, SHCNF_IDLIST, 0&, 0&
End Sub

Public Sub EmptyRecycleBin()
    Const SHERB_NOCONFIRMATION As Long = &H1
    
    SHEmptyRecycleBin 0&, vbNullString, SHERB_NOCONFIRMATION
End Sub


Public Function FormatSize(ByVal Size As Currency) As String
    Const Kilobyte As Currency = 1024@
    Const HundredK As Currency = 102400@
    Const ThousandK As Currency = 1024000@
    Const Megabyte As Currency = 1048576@
    Const HundredMeg As Currency = 104857600@
    Const ThousandMeg As Currency = 1048576000@
    Const Gigabyte As Currency = 1073741824@
    Const Terabyte As Currency = 1099511627776@
    
    If Size < Kilobyte Then
        FormatSize = Int(Size) & " bytes"
    ElseIf Size < HundredK Then
        FormatSize = Format(Size / Kilobyte, "#.0") & " KB"
    ElseIf Size < ThousandK Then
        FormatSize = Int(Size / Kilobyte) & " KB"
    ElseIf Size < HundredMeg Then
        FormatSize = Format(Size / Megabyte, "#.0") & " MB"
    ElseIf Size < ThousandMeg Then
        FormatSize = Int(Size / Megabyte) & " MB"
    ElseIf Size < Terabyte Then
        FormatSize = Format(Size / Gigabyte, "#.00") & " GB"
    Else
        FormatSize = Format(Size / Terabyte, "#.00") & " TB"
    End If
End Function

' Get desktop coords excluding any taskbars
' Thanks to bushmobile from vbforums.com
Public Sub GetDesktop(Left As Long, Top As Long, Width As Long, Height As Long)
    Const SPI_GETWORKAREA As Long = 48
    Dim rc As rect
    
    Call SystemParametersInfo(SPI_GETWORKAREA, 0&, rc, 0&)
    With rc
        Left = .Left * Screen.TwipsPerPixelX
        Top = .Top * Screen.TwipsPerPixelY
        Width = (.Right - .Left) * Screen.TwipsPerPixelX
        Height = (.Bottom - .Top) * Screen.TwipsPerPixelY
    End With
End Sub

' Suppress paint requests to a window
' (reduces flicker, but don't abuse as a crutch)
Public Sub LockWindow(ByVal hwnd As Long)
    mlngLockCount = mlngLockCount + 1
    If mlngLockCount = 1 Then LockWindowUpdate hwnd
End Sub


' Launch default browser
Public Sub OpenURL(ByVal URL As String)
    ShellExecute 0&, "OPEN", URL, vbNullString, vbNullString, vbNormalFocus
End Sub

' Set/unset a form as AlwaysOnTop
Public Sub SetAlwaysOnTop(ByVal hwnd As Long, Optional ByVal AlwaysOnTop As Boolean = True)
    Const SWP_NOSIZE = &H1
    Const SWP_NOMOVE = &H2
    Const SWP_SHOWWINDOW = &H40
    Const HWND_NOTOPMOST = -2
    Const HWND_TOPMOST = -1
    
    If AlwaysOnTop Then
        SetWindowPos hwnd, HWND_TOPMOST, 0&, 0&, 0&, 0&, SWP_NOMOVE Or SWP_NOSIZE Or SWP_SHOWWINDOW
    Else
        SetWindowPos hwnd, HWND_NOTOPMOST, 0&, 0&, 0&, 0&, SWP_NOMOVE Or SWP_NOSIZE Or SWP_SHOWWINDOW
    End If
End Sub

' Move the mouse cursor
Public Sub SetMousePosition(ByVal PixelX As Long, ByVal PixelY As Long)
    If PixelX < 0 Then PixelX = 0
    If PixelY < 0 Then PixelY = 0
    With Screen
        If PixelX > .Width Then PixelX = .Width
        If PixelY > .Height Then PixelY = .Height
    End With
    SetCursorPos PixelX, PixelY
End Sub

' Common Dialog - Open
Public Function ShowOpenDialog(pstrInitialPath As String, pstrFilter As String, pstrDefaultExt As String) As String
    Dim typFileName As OPENFILENAME
            
    typFileName = GetStructure(pstrInitialPath, "", pstrFilter, pstrDefaultExt, feOpen)
    If GetOpenFileName(typFileName) Then ShowOpenDialog = Left$(typFileName.lpstrFile, InStr(typFileName.lpstrFile, Chr$(0)) - 1)
End Function

' Common Dialog - SaveAs
Public Function ShowSaveAsDialog(pstrInitialPath As String, pstrFile As String, pstrFilter As String, pstrDefaultExt As String) As String
    Dim typFileName As OPENFILENAME
            
    typFileName = GetStructure(pstrInitialPath, pstrFile, pstrFilter, pstrDefaultExt, feSaveAs)
    If GetOpenFileName(typFileName) Then ShowSaveAsDialog = Left$(typFileName.lpstrFile, InStr(typFileName.lpstrFile, Chr$(0)) - 1)
End Function

' Shut down windows, and optional reboot it
' if the 2nd argument is True, no WM_QUERYENDSESSION and WM_ENDSESSION
' messages are sent to active applications
Public Sub ShutDownWindows(Optional ByVal Reboot As Boolean = False, Optional ByVal Force As Boolean)
    Const EWX_LOGOFF = 0
    Const EWX_SHUTDOWN = 1
    Const EWX_REBOOT = 2
    Const EWX_FORCE = 4
    Const EWX_POWEROFF = 8
    Const TOKEN_ADJUST_PRIVILEGES = &H20
    Const TOKEN_QUERY = &H8
    Const SE_PRIVILEGE_ENABLED = &H2
    Dim hToken As Long
    Dim tp As TOKEN_PRIVILEGES
    Dim Flags As Long
    
    ' Windows NT/2000 require a special treatment
    ' to ensure that the calling process has the
    ' privileges to shut down the system
    
    ' under NT the high-order bit (that is, the sign bit)
    ' of the value retured by GetVersion is cleared
    If GetVersion() >= 0 Then
        ' Open this process for adjusting its privileges
        OpenProcessToken GetCurrentProcess(), (TOKEN_ADJUST_PRIVILEGES Or TOKEN_QUERY), hToken
        
        ' Get the LUID for shutdown privilege.
        ' retrieves the locally unique identifier (LUID) used
        ' to locally represent the specified privilege name
        ' (first argument = "" means the local system)
        LookupPrivilegeValue "", "SeShutdownPrivilege", tp.LuidUDT
        
        ' complete the TOKEN_PRIVILEGES structure with the # of
        ' privileges and the desired attribute
        tp.PrivilegeCount = 1
        tp.Attributes = SE_PRIVILEGE_ENABLED
        
        ' enables or disables privileges in the specified access token
        ' last 3 arguments are zero because we aren't interested
        ' in previous privilege attributes.
        AdjustTokenPrivileges hToken, False, tp, 0, ByVal 0&, ByVal 0&
    End If
    
    ' prepare shutdown flags
    Flags = EWX_SHUTDOWN
    If Reboot Then
        Flags = Flags Or EWX_REBOOT
    Else
        Flags = Flags Or EWX_POWEROFF
    End If
    If Force Then Flags = Flags Or EWX_FORCE
    
    ' finally, you can shut down Windows
    ExitWindowsEx Flags, &HFFFF
End Sub

Public Function SystemColorRGB(plngSystemColor As Long) As Long
    Const S_OK = &H0
    Dim lngReturn As Long
    
    If OleTranslateColor(plngSystemColor, 0, lngReturn) = S_OK Then SystemColorRGB = lngReturn Else lngReturn = -1
End Function

' Enable paint requests
Public Sub UnlockWindow()
    mlngLockCount = mlngLockCount - 1
    If mlngLockCount = 0 Then LockWindowUpdate 0
End Sub



' PROPERTIES


' Debug Mode
Public Property Get DebugMode() As Boolean
    DebugMode = (App.LogMode = 0)
End Property


' Drive class
Public Property Get Drive() As clsDrive
    Set Drive = mclsDrive
End Property

Public Property Set Drive(pcls As clsDrive)
    Set mclsDrive = pcls
End Property


' File class
Public Property Get File() As clsFile
    Set File = mclsFile
End Property

Public Property Set File(pcls As clsFile)
    Set mclsFile = pcls
End Property


' Folder class
Public Property Get Folder() As clsFolder
    Set Folder = mclsFolder
End Property

Public Property Set Folder(pcls As clsFolder)
    Set mclsFolder = pcls
End Property


' Set mouse cursor
Public Property Let Mouse(ByVal penState As MouseStateEnum)
    Dim lngSysPointer As Long
    Dim lngFormPointer As Long

    menMouse = penState
    If menMouse = msWait Then lngFormPointer = vbHourglass Else lngFormPointer = vbNormal
    If menMouse = msSystemWait Then lngSysPointer = vbHourglass Else lngSysPointer = vbNormal
    ' Hide/Show mouse
    If menMouse = msHidden Then
        Do While ShowCursor(False) >= 0
        Loop
    Else
        Do While ShowCursor(True) < 0
        Loop
    End If
    ' Set the cursor
    Screen.MousePointer = lngSysPointer
    If Not (Screen.ActiveForm Is Nothing) Then Screen.ActiveForm.MousePointer = lngFormPointer
End Property

Public Property Get Mouse() As MouseStateEnum
    Mouse = menMouse
End Property


' Registry class
Public Property Get Registry() As clsRegistry
    Set Registry = mclsRegistry
End Property

Public Property Set Registry(pcls As clsRegistry)
    Set mclsRegistry = pcls
End Property


' Get current Windows UserName
Public Property Get UserName() As String
    Dim strUser As String * 50
    Dim lngLen As Long

    lngLen = 50
    If GetUserName(strUser, lngLen) = 0 Then
        UserName = ""
    Else
        UserName = Left$(strUser, lngLen - 1)
    End If
End Property



' INTERNAL FUNCTIONS


Private Sub Class_Initialize()
    menMouse = msNormal
    Set mclsDrive = New clsDrive
    Set mclsFile = New clsFile
    Set mclsFolder = New clsFolder
    Set mclsRegistry = New clsRegistry
    mlngLockCount = 0
End Sub

Private Sub Class_Terminate()
    Me.Mouse = msNormal
    Set mclsDrive = Nothing
    Set mclsFile = Nothing
    Set mclsFolder = Nothing
    Set mclsRegistry = Nothing
End Sub

Private Function GetStructure(pstrPath As String, pstrFile As String, pstrFilter As String, pstrDefaultExt As String, penFlags As FlagsEnum) As OPENFILENAME
    Const OFN_FILEMUSTEXIST = &H1000
    Const OFN_PATHMUSTEXIST = &H800
    Const OFN_HIDEREADONLY = &H4
    Const OFN_LONGNAMES = &H200000
    Const OFN_OVERWRITEPROMPT = &H2
    Const OF_WRITE = &H1
    Const MAX_PATH = 260
    Dim frm As Form

    With GetStructure
        .lStructSize = Len(GetStructure)
        ' Get any form's window handle
        For Each frm In Forms
            Exit For
        Next
        .hwndOwner = frm.hwnd
        Set frm = Nothing
        .hInstance = App.hInstance
        .lpstrFilter = Replace(pstrFilter, "|", Chr(0)) & Chr(0)
        .nMaxFile = MAX_PATH + 1
        .nMaxFileTitle = MAX_PATH + 1
        .lpstrFileTitle = Space(MAX_PATH)
        .lpstrInitialDir = pstrPath
        .lpstrDefExt = pstrDefaultExt
        Select Case penFlags
            Case feOpen
                .lpstrTitle = "Open"
                .lpstrFile = Space(MAX_PATH)
                .Flags = OFN_FILEMUSTEXIST + OFN_HIDEREADONLY + OFN_LONGNAMES
            Case feSaveAs
                .lpstrTitle = "Save As"
                .lpstrFile = pstrFile & Space$(MAX_PATH - Len(pstrFile))
                .Flags = OFN_PATHMUSTEXIST + OFN_HIDEREADONLY + OFN_LONGNAMES + OFN_OVERWRITEPROMPT + OF_WRITE
        End Select
    End With
End Function
