Attribute VB_Name = "basSort2"
' Sort two-dimensional array
' Written by Ellis Dee of vbforums.com
Option Explicit
Option Compare Text

' Sort a 2-dimensional array on either dimension
' Sample usage to sort on column 4
' Dim MyArray(1 to 5, 1 to 1000) As Long
' BubbleSort2 MyArray, 1, 4
' Dim MyArray(1 to 1000, 1 to 5) As Long
' BubbleSort2 MyArray, 2, 4
Public Sub BubbleSort2(ByRef pvarArray As Variant, plngDim As Long, plngCol As Long)
    Dim i As Long
    Dim iMin As Long
    Dim iMax As Long
    Dim varSwap As Variant
    Dim blnSwapped As Boolean
    Dim c As Long
    Dim cMin As Long
    Dim cMax As Long
    
    cMin = LBound(pvarArray, plngDim)
    cMax = UBound(pvarArray, plngDim)
    Select Case plngDim
        Case 1
            iMin = LBound(pvarArray, 2)
            iMax = UBound(pvarArray, 2) - 1
            Do
                blnSwapped = False
                For i = iMin To iMax
                    If pvarArray(plngCol, i) > pvarArray(plngCol, i + 1) Then
                        For c = cMin To cMax
                            varSwap = pvarArray(c, i)
                            pvarArray(c, i) = pvarArray(c, i + 1)
                            pvarArray(c, i + 1) = varSwap
                        Next
                        blnSwapped = True
                    End If
                Next
                iMax = iMax - 1
            Loop Until Not blnSwapped
        Case 2
            iMin = LBound(pvarArray, 1)
            iMax = UBound(pvarArray, 1) - 1
            Do
                blnSwapped = False
                For i = iMin To iMax
                    If pvarArray(i, plngCol) > pvarArray(i + 1, plngCol) Then
                        For c = cMin To cMax
                            varSwap = pvarArray(i, c)
                            pvarArray(i, c) = pvarArray(i + 1, c)
                            pvarArray(i + 1, c) = varSwap
                        Next
                        blnSwapped = True
                    End If
                Next
                iMax = iMax - 1
            Loop Until Not blnSwapped
    End Select
End Sub

' Sort a 2-dimensional array on either dimension
' Sample usage to sort on column 4
' Dim MyArray(1 to 5, 1 to 1000) As Long
' CocktailSort2 MyArray, 1, 4
' Dim MyArray(1 to 1000, 1 to 5) As Long
' CocktailSort2 MyArray, 2, 4
Public Sub CocktailSort2(ByRef pvarArray As Variant, plngDim As Long, plngCol As Long)
    Dim i As Long
    Dim iMin As Long
    Dim iMax As Long
    Dim varSwap As Variant
    Dim blnSwapped As Boolean
    Dim c As Long
    Dim cMin As Long
    Dim cMax As Long
    
    cMin = LBound(pvarArray, plngDim)
    cMax = UBound(pvarArray, plngDim)
    Select Case plngDim
        Case 1
            iMin = LBound(pvarArray, 2)
            iMax = UBound(pvarArray, 2) - 1
            Do
                blnSwapped = False
                For i = iMin To iMax
                    If pvarArray(plngCol, i) > pvarArray(plngCol, i + 1) Then
                        For c = cMin To cMax
                            varSwap = pvarArray(c, i)
                            pvarArray(c, i) = pvarArray(c, i + 1)
                            pvarArray(c, i + 1) = varSwap
                        Next
                        blnSwapped = True
                    End If
                Next
                iMax = iMax - 1
                If Not blnSwapped Then Exit Do
                For i = iMax To iMin Step -1
                    If pvarArray(plngCol, i) > pvarArray(plngCol, i + 1) Then
                        For c = cMin To cMax
                            varSwap = pvarArray(c, i)
                            pvarArray(c, i) = pvarArray(c, i + 1)
                            pvarArray(c, i + 1) = varSwap
                        Next
                        blnSwapped = True
                    End If
                Next
                iMin = iMin + 1
            Loop Until Not blnSwapped
        Case 2
            iMin = LBound(pvarArray, 1)
            iMax = UBound(pvarArray, 1) - 1
            Do
                blnSwapped = False
                For i = iMin To iMax
                    If pvarArray(i, plngCol) > pvarArray(i + 1, plngCol) Then
                        For c = cMin To cMax
                            varSwap = pvarArray(i, c)
                            pvarArray(i, c) = pvarArray(i + 1, c)
                            pvarArray(i + 1, c) = varSwap
                        Next
                        blnSwapped = True
                    End If
                Next
                iMax = iMax - 1
                If Not blnSwapped Then Exit Do
                For i = iMax To iMin Step -1
                    If pvarArray(i, plngCol) > pvarArray(i + 1, plngCol) Then
                        For c = cMin To cMax
                            varSwap = pvarArray(i, c)
                            pvarArray(i, c) = pvarArray(i + 1, c)
                            pvarArray(i + 1, c) = varSwap
                        Next
                        blnSwapped = True
                    End If
                Next
                iMin = iMin + 1
            Loop Until Not blnSwapped
    End Select
End Sub

' Sort a 2-dimensional array on either dimension
' Sample usage to sort on column 4
' Dim MyArray(1 to 5, 1 to 1000) As Long
' CombSort2 MyArray, 1, 4
' Dim MyArray(1 to 1000, 1 to 5) As Long
' CombSort2 MyArray, 2, 4
Public Sub CombSort2(ByRef pvarArray As Variant, plngDim As Long, plngCol As Long)
    Const ShrinkFactor = 1.3
    Dim lngGap As Long
    Dim i As Long
    Dim iMin As Long
    Dim iMax As Long
    Dim varSwap As Variant
    Dim blnSwapped As Boolean
    Dim c As Long
    Dim cMin As Long
    Dim cMax As Long
    
    cMin = LBound(pvarArray, plngDim)
    cMax = UBound(pvarArray, plngDim)
    Select Case plngDim
        Case 1
            iMin = LBound(pvarArray, 2)
            iMax = UBound(pvarArray, 2)
            lngGap = iMax - iMin + 1
            Do
                If lngGap > 1 Then
                    lngGap = Int(lngGap / ShrinkFactor)
                    If lngGap = 10 Or lngGap = 9 Then lngGap = 11
                End If
                blnSwapped = False
                For i = iMin To iMax - lngGap
                    If pvarArray(plngCol, i) > pvarArray(plngCol, i + lngGap) Then
                        For c = cMin To cMax
                            varSwap = pvarArray(c, i)
                            pvarArray(c, i) = pvarArray(c, i + lngGap)
                            pvarArray(c, i + lngGap) = varSwap
                        Next
                        blnSwapped = True
                    End If
                Next
            Loop Until lngGap = 1 And Not blnSwapped
        Case 2
            iMin = LBound(pvarArray, 1)
            iMax = UBound(pvarArray, 1)
            lngGap = iMax - iMin + 1
            Do
                If lngGap > 1 Then
                    lngGap = Int(lngGap / ShrinkFactor)
                    If lngGap = 10 Or lngGap = 9 Then lngGap = 11
                End If
                blnSwapped = False
                For i = iMin To iMax - lngGap
                    If pvarArray(i, plngCol) > pvarArray(i + lngGap, plngCol) Then
                        For c = cMin To cMax
                            varSwap = pvarArray(i, c)
                            pvarArray(i, c) = pvarArray(i + lngGap, c)
                            pvarArray(i + lngGap, c) = varSwap
                        Next
                        blnSwapped = True
                    End If
                Next
            Loop Until lngGap = 1 And Not blnSwapped
    End Select
End Sub

' Sort a 2-dimensional array on either dimension
' Sample usage to sort on column 4
' Dim MyArray(1 to 5, 1 to 1000) As Long
' GnomeSort2 MyArray, 1, 4
' Dim MyArray(1 to 1000, 1 to 5) As Long
' GnomeSort2 MyArray, 2, 4
Public Sub GnomeSort2(ByRef pvarArray As Variant, plngDim As Long, plngCol As Long)
    Dim i As Long
    Dim j As Long
    Dim iMin As Long
    Dim iMax As Long
    Dim varSwap As Variant
    Dim c As Long
    Dim cMin As Long
    Dim cMax As Long
    
    cMin = LBound(pvarArray, plngDim)
    cMax = UBound(pvarArray, plngDim)
    Select Case plngDim
        Case 1
            iMin = LBound(pvarArray, 2) + 1
            iMax = UBound(pvarArray, 2)
            i = iMin
            j = i + 1
            Do While i <= iMax
                If pvarArray(plngCol, i) < pvarArray(plngCol, i - 1) Then
                    For c = cMin To cMax
                        varSwap = pvarArray(c, i)
                        pvarArray(c, i) = pvarArray(c, i - 1)
                        pvarArray(c, i - 1) = varSwap
                    Next
                    If i > iMin Then i = i - 1
                Else
                    i = j
                    j = j + 1
                End If
            Loop
        Case 2
            iMin = LBound(pvarArray, 1) + 1
            iMax = UBound(pvarArray, 1)
            i = iMin
            j = i + 1
            Do While i <= iMax
                If pvarArray(i, plngCol) < pvarArray(i - 1, plngCol) Then
                    For c = cMin To cMax
                        varSwap = pvarArray(i, c)
                        pvarArray(i, c) = pvarArray(i - 1, c)
                        pvarArray(i - 1, c) = varSwap
                    Next
                    If i > iMin Then i = i - 1
                Else
                    i = j
                    j = j + 1
                End If
            Loop
    End Select
End Sub

' Sort a 2-dimensional array on either dimension
' Sample usage to sort on column 4
' Dim MyArray(1 to 5, 1 to 1000) As Long
' HeapSort2 MyArray, 1, 4
' Dim MyArray(1 to 1000, 1 to 5) As Long
' HeapSort2 MyArray, 2, 4
Public Sub HeapSort2(ByRef pvarArray As Variant, plngDim As Long, plngCol As Long)
    Dim i As Long
    Dim iMin As Long
    Dim iMax As Long
    Dim varSwap As Variant
    Dim c As Long
    Dim cMin As Long
    Dim cMax As Long
    
    cMin = LBound(pvarArray, plngDim)
    cMax = UBound(pvarArray, plngDim)
    Select Case plngDim
        Case 1
            iMin = LBound(pvarArray, 2)
            iMax = UBound(pvarArray, 2)
            For i = (iMax + iMin) \ 2 To iMin Step -1
                Heap2 pvarArray, i, iMin, iMax, plngDim, plngCol, cMin, cMax
            Next i
            For i = iMax To iMin + 1 Step -1
                For c = cMin To cMax
                    varSwap = pvarArray(c, i)
                    pvarArray(c, i) = pvarArray(c, iMin)
                    pvarArray(c, iMin) = varSwap
                Next
                Heap2 pvarArray, iMin, iMin, i - 1, plngDim, plngCol, cMin, cMax
            Next i
        Case 2
            iMin = LBound(pvarArray, 1)
            iMax = UBound(pvarArray, 1)
            For i = (iMax + iMin) \ 2 To iMin Step -1
                Heap2 pvarArray, i, iMin, iMax, plngDim, plngCol, cMin, cMax
            Next i
            For i = iMax To iMin + 1 Step -1
                For c = cMin To cMax
                    varSwap = pvarArray(i, c)
                    pvarArray(i, c) = pvarArray(iMin, c)
                    pvarArray(iMin, c) = varSwap
                Next
                Heap2 pvarArray, iMin, iMin, i - 1, plngDim, plngCol, cMin, cMax
            Next i
    End Select
End Sub

Private Sub Heap2(ByRef pvarArray As Variant, ByVal i As Long, iMin As Long, iMax As Long, plngDim As Long, plngCol As Long, cMin As Long, cMax As Long)
    Dim lngLeaf As Long
    Dim varSwap As Variant
    Dim c As Long
    
    Select Case plngDim
        Case 1
            Do
                lngLeaf = i + i - (iMin - 1)
                Select Case lngLeaf
                    Case Is > iMax: Exit Do
                    Case Is < iMax: If pvarArray(plngCol, lngLeaf + 1) > pvarArray(plngCol, lngLeaf) Then lngLeaf = lngLeaf + 1
                End Select
                If pvarArray(plngCol, i) > pvarArray(plngCol, lngLeaf) Then Exit Do
                For c = cMin To cMax
                    varSwap = pvarArray(c, i)
                    pvarArray(c, i) = pvarArray(c, lngLeaf)
                    pvarArray(c, lngLeaf) = varSwap
                Next
                i = lngLeaf
            Loop
        Case 2
            Do
                lngLeaf = i + i - (iMin - 1)
                Select Case lngLeaf
                    Case Is > iMax: Exit Do
                    Case Is < iMax: If pvarArray(lngLeaf + 1, plngCol) > pvarArray(lngLeaf, plngCol) Then lngLeaf = lngLeaf + 1
                End Select
                If pvarArray(i, plngCol) > pvarArray(lngLeaf, plngCol) Then Exit Do
                For c = cMin To cMax
                    varSwap = pvarArray(i, c)
                    pvarArray(i, c) = pvarArray(lngLeaf, c)
                    pvarArray(lngLeaf, c) = varSwap
                Next
                i = lngLeaf
            Loop
    End Select
End Sub

' Sort a 2-dimensional array on either dimension
' Sample usage to sort on column 4
' Dim MyArray(1 to 5, 1 to 1000) As Long
' InsertionSort2 MyArray, 1, 4
' Dim MyArray(1 to 1000, 1 to 5) As Long
' InsertionSort2 MyArray, 2, 4
Public Sub InsertionSort2(pvarArray As Variant, plngDim As Long, plngCol As Long)
    Dim i As Long
    Dim j As Long
    Dim iMin As Long
    Dim iMax As Long
    Dim varSwap As Variant
    Dim c As Long
    Dim cMin As Long
    Dim cMax As Long
    
    cMin = LBound(pvarArray, plngDim)
    cMax = UBound(pvarArray, plngDim)
    ReDim varSwap(cMin To cMax)
    Select Case plngDim
        Case 1
            iMin = LBound(pvarArray, 2) + 1
            iMax = UBound(pvarArray, 2)
            For i = iMin To iMax
                For c = cMin To cMax
                    varSwap(c) = pvarArray(c, i)
                Next
                For j = i To iMin Step -1
                    If varSwap(plngCol) < pvarArray(plngCol, j - 1) Then
                        For c = cMin To cMax
                            pvarArray(c, j) = pvarArray(c, j - 1)
                        Next
                    Else
                        Exit For
                    End If
                Next j
                For c = cMin To cMax
                    pvarArray(c, j) = varSwap(c)
                Next
            Next i
        Case 2
            iMin = LBound(pvarArray, 1) + 1
            iMax = UBound(pvarArray, 1)
            For i = iMin To iMax
                For c = cMin To cMax
                    varSwap(c) = pvarArray(i, c)
                Next
                For j = i To iMin Step -1
                    If varSwap(plngCol) < pvarArray(j - 1, plngCol) Then
                        For c = cMin To cMax
                            pvarArray(j, c) = pvarArray(j - 1, c)
                        Next
                    Else
                        Exit For
                    End If
                Next j
                For c = cMin To cMax
                    pvarArray(j, c) = varSwap(c)
                Next
            Next i
    End Select
End Sub

' Sort a 2-dimensional array on either dimension
' Sample usage to sort on column 4
' Dim MyArray(1 to 5, 1 to 1000) As Long
' JumpSort2 MyArray, 1, 4
' Dim MyArray(1 to 1000, 1 to 5) As Long
' JumpSort2 MyArray, 2, 4
Public Sub JumpSort2(pvarArray As Variant, plngDim As Long, plngCol As Long)
    Dim lngJump As Long
    Dim i As Long
    Dim iMin As Long
    Dim iMax As Long
    Dim varSwap As Variant
    Dim blnSwapped As Boolean
    Dim c As Long
    Dim cMin As Long
    Dim cMax As Long
    
    cMin = LBound(pvarArray, plngDim)
    cMax = UBound(pvarArray, plngDim)
    Select Case plngDim
        Case 1
            iMin = LBound(pvarArray, 2)
            iMax = UBound(pvarArray, 2)
            lngJump = iMax - iMin
            Do
                lngJump = lngJump \ 2
                Do
                    blnSwapped = False
                    For i = iMin To iMax - lngJump
                        If pvarArray(plngCol, i) > pvarArray(plngCol, i + lngJump) Then
                            For c = cMin To cMax
                                varSwap = pvarArray(c, i)
                                pvarArray(c, i) = pvarArray(c, i + lngJump)
                                pvarArray(c, i + lngJump) = varSwap
                            Next
                            blnSwapped = True
                        End If
                    Next
                Loop Until Not blnSwapped
            Loop Until lngJump = 0
        Case 2
            iMin = LBound(pvarArray, 1)
            iMax = UBound(pvarArray, 1)
            lngJump = iMax - iMin
            Do
                lngJump = lngJump \ 2
                Do
                    blnSwapped = False
                    For i = iMin To iMax - lngJump
                        If pvarArray(i, plngCol) > pvarArray(i + lngJump, plngCol) Then
                            For c = cMin To cMax
                                varSwap = pvarArray(i, c)
                                pvarArray(i, c) = pvarArray(i + lngJump, c)
                                pvarArray(i + lngJump, c) = varSwap
                            Next
                            blnSwapped = True
                        End If
                    Next
                Loop Until Not blnSwapped
            Loop Until lngJump = 0
    End Select
End Sub

' Sort a 2-dimensional array on either dimension
' Omit pvarMirror, plngLeft & plngRight; they are used internally during recursion
' Sample usage to sort on column 4
' Dim MyArray(1 to 1000, 1 to 5) As Long
' MergeSort2 MyArray, 2, 4
' Dim MyArray(1 to 5, 1 to 1000) As Long
' MergeSort2 MyArray, 1, 4
Public Sub MergeSort2(ByRef pvarArray As Variant, plngDim As Long, plngCol As Long, Optional pvarMirror As Variant, Optional ByVal plngLeft As Long, Optional ByVal plngRight As Long)
    Dim lngMid As Long
    Dim L As Long
    Dim R As Long
    Dim O As Long
    Dim varSwap As Variant
    Dim c As Long
    Dim cMin As Long
    Dim cMax As Long
    
    cMin = LBound(pvarArray, plngDim)
    cMax = UBound(pvarArray, plngDim)
    Select Case plngDim
        Case 1
            If plngRight = 0 Then
                plngLeft = LBound(pvarArray, 2)
                plngRight = UBound(pvarArray, 2)
                ReDim pvarMirror(cMin To cMax, plngLeft To plngRight)
            End If
            lngMid = plngRight - plngLeft
            Select Case lngMid
                Case 0
                Case 1
                    If pvarArray(plngCol, plngLeft) > pvarArray(plngCol, plngRight) Then
                        For c = cMin To cMax
                            varSwap = pvarArray(c, plngLeft)
                            pvarArray(c, plngLeft) = pvarArray(c, plngRight)
                            pvarArray(c, plngRight) = varSwap
                        Next
                    End If
                Case Else
                    lngMid = lngMid \ 2 + plngLeft
                    MergeSort2 pvarArray, plngDim, plngCol, pvarMirror, plngLeft, lngMid
                    MergeSort2 pvarArray, plngDim, plngCol, pvarMirror, lngMid + 1, plngRight
                    ' Merge the resulting halves
                    L = plngLeft ' start of first (left) half
                    R = lngMid + 1 ' start of second (right) half
                    O = plngLeft ' start of output (mirror array)
                    Do
                        If pvarArray(plngCol, R) < pvarArray(plngCol, L) Then
                            For c = cMin To cMax
                                pvarMirror(c, O) = pvarArray(c, R)
                            Next
                            R = R + 1
                            If R > plngRight Then
                                For L = L To lngMid
                                    O = O + 1
                                    For c = cMin To cMax
                                        pvarMirror(c, O) = pvarArray(c, L)
                                    Next
                                Next
                                Exit Do
                            End If
                        Else
                            For c = cMin To cMax
                                pvarMirror(c, O) = pvarArray(c, L)
                            Next
                            L = L + 1
                            If L > lngMid Then
                                For R = R To plngRight
                                    O = O + 1
                                    For c = cMin To cMax
                                        pvarMirror(c, O) = pvarArray(c, R)
                                    Next
                                Next
                                Exit Do
                            End If
                        End If
                        O = O + 1
                    Loop
                    For O = plngLeft To plngRight
                        For c = cMin To cMax
                            pvarArray(c, O) = pvarMirror(c, O)
                        Next
                    Next
            End Select
        Case 2
            If plngRight = 0 Then
                plngLeft = LBound(pvarArray, 1)
                plngRight = UBound(pvarArray, 1)
                ReDim pvarMirror(plngLeft To plngRight, cMin To cMax)
            End If
            lngMid = plngRight - plngLeft
            Select Case lngMid
                Case 0
                Case 1
                    If pvarArray(plngLeft, plngCol) > pvarArray(plngRight, plngCol) Then
                        For c = cMin To cMax
                            varSwap = pvarArray(plngLeft, c)
                            pvarArray(plngLeft, c) = pvarArray(plngRight, c)
                            pvarArray(plngRight, c) = varSwap
                        Next
                    End If
                Case Else
                    lngMid = lngMid \ 2 + plngLeft
                    MergeSort2 pvarArray, plngDim, plngCol, pvarMirror, plngLeft, lngMid
                    MergeSort2 pvarArray, plngDim, plngCol, pvarMirror, lngMid + 1, plngRight
                    ' Merge the resulting halves
                    L = plngLeft ' start of first (left) half
                    R = lngMid + 1 ' start of second (right) half
                    O = plngLeft ' start of output (mirror array)
                    Do
                        If pvarArray(R, plngCol) < pvarArray(L, plngCol) Then
                            For c = cMin To cMax
                                pvarMirror(O, c) = pvarArray(R, c)
                            Next
                            R = R + 1
                            If R > plngRight Then
                                For L = L To lngMid
                                    O = O + 1
                                    For c = cMin To cMax
                                        pvarMirror(O, c) = pvarArray(L, c)
                                    Next
                                Next
                                Exit Do
                            End If
                        Else
                            For c = cMin To cMax
                                pvarMirror(O, c) = pvarArray(L, c)
                            Next
                            L = L + 1
                            If L > lngMid Then
                                For R = R To plngRight
                                    O = O + 1
                                    For c = cMin To cMax
                                        pvarMirror(O, c) = pvarArray(R, c)
                                    Next
                                Next
                                Exit Do
                            End If
                        End If
                        O = O + 1
                    Loop
                    For O = plngLeft To plngRight
                        For c = cMin To cMax
                            pvarArray(O, c) = pvarMirror(O, c)
                        Next
                    Next
            End Select
    End Select
End Sub

' Sort a 2-dimensional array on either dimension
' Omit plngLeft & plngRight; they are used internally during recursion
' Sample usage to sort on column 4
' Dim MyArray(1 to 1000, 1 to 5) As Long
' QuickSort2 MyArray, 2, 4
' Dim MyArray(1 to 5, 1 to 1000) As Long
' QuickSort2 MyArray, 1, 4
Public Sub QuickSort2(ByRef pvarArray As Variant, plngDim As Long, plngCol As Long, Optional ByVal plngLeft As Long, Optional ByVal plngRight As Long)
    Dim lngFirst As Long
    Dim lngLast As Long
    Dim varMid As Variant
    Dim varSwap As Variant
    Dim c As Long
    Dim cMin As Long
    Dim cMax As Long
    
    cMin = LBound(pvarArray, plngDim)
    cMax = UBound(pvarArray, plngDim)
    Select Case plngDim
        Case 1
            If plngRight = 0 Then
                plngLeft = LBound(pvarArray, 2)
                plngRight = UBound(pvarArray, 2)
            End If
            lngFirst = plngLeft
            lngLast = plngRight
            varMid = pvarArray(plngCol, (plngLeft + plngRight) \ 2)
            Do
                Do While pvarArray(plngCol, lngFirst) < varMid And lngFirst < plngRight
                    lngFirst = lngFirst + 1
                Loop
                Do While varMid < pvarArray(plngCol, lngLast) And lngLast > plngLeft
                    lngLast = lngLast - 1
                Loop
                If lngFirst <= lngLast Then
                    For c = cMin To cMax
                        varSwap = pvarArray(c, lngFirst)
                        pvarArray(c, lngFirst) = pvarArray(c, lngLast)
                        pvarArray(c, lngLast) = varSwap
                    Next
                    lngFirst = lngFirst + 1
                    lngLast = lngLast - 1
                End If
            Loop Until lngFirst > lngLast
            If plngLeft < lngLast Then QuickSort2 pvarArray, plngDim, plngCol, plngLeft, lngLast
            If lngFirst < plngRight Then QuickSort2 pvarArray, plngDim, plngCol, lngFirst, plngRight
        Case 2
            If plngRight = 0 Then
                plngLeft = LBound(pvarArray, 1)
                plngRight = UBound(pvarArray, 1)
            End If
            lngFirst = plngLeft
            lngLast = plngRight
            varMid = pvarArray((plngLeft + plngRight) \ 2, plngCol)
            Do
                Do While pvarArray(lngFirst, plngCol) < varMid And lngFirst < plngRight
                    lngFirst = lngFirst + 1
                Loop
                Do While varMid < pvarArray(lngLast, plngCol) And lngLast > plngLeft
                    lngLast = lngLast - 1
                Loop
                If lngFirst <= lngLast Then
                    For c = cMin To cMax
                        varSwap = pvarArray(lngFirst, c)
                        pvarArray(lngFirst, c) = pvarArray(lngLast, c)
                        pvarArray(lngLast, c) = varSwap
                    Next
                    lngFirst = lngFirst + 1
                    lngLast = lngLast - 1
                End If
            Loop Until lngFirst > lngLast
            If plngLeft < lngLast Then QuickSort2 pvarArray, plngDim, plngCol, plngLeft, lngLast
            If lngFirst < plngRight Then QuickSort2 pvarArray, plngDim, plngCol, lngFirst, plngRight
    End Select
End Sub

' Sort a 2-dimensional array on either dimension
' Sample usage to sort on column 4
' Dim MyArray(1 to 5, 1 to 1000) As Long
' SelectionSort2 MyArray, 1, 4
' Dim MyArray(1 to 1000, 1 to 5) As Long
' SelectionSort2 MyArray, 2, 4
Public Sub SelectionSort2(pvarArray As Variant, plngDim As Long, plngCol As Long)
    Dim i As Long
    Dim j As Long
    Dim iMin As Long
    Dim iMax As Long
    Dim varSwap As Variant
    Dim c As Long
    Dim cMin As Long
    Dim cMax As Long
    
    cMin = LBound(pvarArray, plngDim)
    cMax = UBound(pvarArray, plngDim)
    Select Case plngDim
        Case 1
            iMin = LBound(pvarArray, 2)
            iMax = UBound(pvarArray, 2)
            For i = iMin To iMax - 1
                iMin = i
                For j = (i + 1) To iMax
                    If pvarArray(plngCol, j) < pvarArray(plngCol, iMin) Then iMin = j
                Next
                For c = cMin To cMax
                    varSwap = pvarArray(c, i)
                    pvarArray(c, i) = pvarArray(c, iMin)
                    pvarArray(c, iMin) = varSwap
                Next
            Next
        Case 2
            iMin = LBound(pvarArray, 1)
            iMax = UBound(pvarArray, 1)
            For i = iMin To iMax - 1
                iMin = i
                For j = (i + 1) To iMax
                    If pvarArray(j, plngCol) < pvarArray(iMin, plngCol) Then iMin = j
                Next
                For c = cMin To cMax
                    varSwap = pvarArray(i, c)
                    pvarArray(i, c) = pvarArray(iMin, c)
                    pvarArray(iMin, c) = varSwap
                Next
            Next
    End Select
End Sub

' Sort a 2-dimensional array on either dimension
' Sample usage to sort on column 4
' Dim MyArray(1 to 5, 1 to 1000) As Long
' ShakerSort2 MyArray, 1, 4
' Dim MyArray(1 to 1000, 1 to 5) As Long
' ShakerSort2 MyArray, 2, 4
Public Function ShakerSort2(ByRef pvarArray As Variant, plngDim As Long, plngCol As Long)
    Dim i As Long
    Dim j As Long
    Dim k As Long
    Dim iMin As Long
    Dim iMax As Long
    Dim varSwap As Variant
    Dim blnSwapped As Boolean
    Dim c As Long
    Dim cMin As Long
    Dim cMax As Long
    
    cMin = LBound(pvarArray, plngDim)
    cMax = UBound(pvarArray, plngDim)
    Select Case plngDim
        Case 1
            iMin = LBound(pvarArray, 2)
            iMax = UBound(pvarArray, 2)
            i = (iMax - iMin) \ 2 + iMin
            Do While i > iMin
                j = i
                Do While j > iMin
                    For k = iMin To iMax - j
                        If pvarArray(plngCol, k) > pvarArray(plngCol, k + j) Then
                            For c = cMin To cMax
                                varSwap = pvarArray(c, k)
                                pvarArray(c, k) = pvarArray(c, k + j)
                                pvarArray(c, k + j) = varSwap
                            Next
                        End If
                    Next
                    j = j \ 2
                Loop
                i = i \ 2
            Loop
            iMax = iMax - 1
            Do
                blnSwapped = False
                For i = iMin To iMax
                    If pvarArray(plngCol, i) > pvarArray(plngCol, i + 1) Then
                        For c = cMin To cMax
                            varSwap = pvarArray(c, i)
                            pvarArray(c, i) = pvarArray(c, i + 1)
                            pvarArray(c, i + 1) = varSwap
                        Next
                        blnSwapped = True
                    End If
                Next i
                If blnSwapped Then
                    blnSwapped = False
                    iMax = iMax - 1
                    For i = iMax To iMin Step -1
                        If pvarArray(plngCol, i) > pvarArray(plngCol, i + 1) Then
                            For c = cMin To cMax
                                varSwap = pvarArray(c, i)
                                pvarArray(c, i) = pvarArray(c, i + 1)
                                pvarArray(c, i + 1) = varSwap
                            Next
                            blnSwapped = True
                        End If
                    Next i
                    iMin = iMin + 1
                End If
            Loop Until Not blnSwapped
        Case 2
            iMin = LBound(pvarArray, 1)
            iMax = UBound(pvarArray, 1)
            i = (iMax - iMin) \ 2 + iMin
            Do While i > iMin
                j = i
                Do While j > iMin
                    For k = iMin To iMax - j
                        If pvarArray(k, plngCol) > pvarArray(k + j, plngCol) Then
                            For c = cMin To cMax
                                varSwap = pvarArray(k, c)
                                pvarArray(k, c) = pvarArray(k + j, c)
                                pvarArray(k + j, c) = varSwap
                            Next
                        End If
                    Next
                    j = j \ 2
                Loop
                i = i \ 2
            Loop
            iMax = iMax - 1
            Do
                blnSwapped = False
                For i = iMin To iMax
                    If pvarArray(i, plngCol) > pvarArray(i + 1, plngCol) Then
                        For c = cMin To cMax
                            varSwap = pvarArray(i, c)
                            pvarArray(i, c) = pvarArray(i + 1, c)
                            pvarArray(i + 1, c) = varSwap
                        Next
                        blnSwapped = True
                    End If
                Next i
                If blnSwapped Then
                    blnSwapped = False
                    iMax = iMax - 1
                    For i = iMax To iMin Step -1
                        If pvarArray(i, plngCol) > pvarArray(i + 1, plngCol) Then
                            For c = cMin To cMax
                                varSwap = pvarArray(i, c)
                                pvarArray(i, c) = pvarArray(i + 1, c)
                                pvarArray(i + 1, c) = varSwap
                            Next
                            blnSwapped = True
                        End If
                    Next i
                    iMin = iMin + 1
                End If
            Loop Until Not blnSwapped
    End Select
End Function

' Sort a 2-dimensional array on either dimension
' Sample usage to sort on column 4
' Dim MyArray(1 to 5, 1 to 1000) As Long
' ShellSort2 MyArray, 1, 4
' Dim MyArray(1 to 1000, 1 to 5) As Long
' ShellSort2 MyArray, 2, 4
Public Sub ShellSort2(pvarArray As Variant, plngDim As Long, plngCol As Long)
    Dim lngHold As Long
    Dim lngGap As Long
    Dim i As Long
    Dim iMin As Long
    Dim iMax As Long
    Dim varSwap As Variant
    Dim c As Long
    Dim cMin As Long
    Dim cMax As Long
    
    cMin = LBound(pvarArray, plngDim)
    cMax = UBound(pvarArray, plngDim)
    ReDim varSwap(cMin To cMax)
    Select Case plngDim
        Case 1
            iMin = LBound(pvarArray, 2)
            iMax = UBound(pvarArray, 2)
            lngGap = iMin
            Do
                lngGap = 3 * lngGap + 1
            Loop Until lngGap > iMax
            Do
                lngGap = lngGap \ 3
                For i = lngGap + iMin To iMax
                    For c = cMin To cMax
                        varSwap(c) = pvarArray(c, i)
                    Next
                    lngHold = i
                    Do While pvarArray(plngCol, lngHold - lngGap) > varSwap(plngCol)
                        For c = cMin To cMax
                            pvarArray(c, lngHold) = pvarArray(c, lngHold - lngGap)
                        Next
                        lngHold = lngHold - lngGap
                        If lngHold < lngGap + iMin Then Exit Do
                    Loop
                    For c = cMin To cMax
                        pvarArray(c, lngHold) = varSwap(c)
                    Next
                Next i
            Loop Until lngGap = 1
        Case 2
            iMin = LBound(pvarArray, 1)
            iMax = UBound(pvarArray, 1)
            lngGap = iMin
            Do
                lngGap = 3 * lngGap + 1
            Loop Until lngGap > iMax
            Do
                lngGap = lngGap \ 3
                For i = lngGap + iMin To iMax
                    For c = cMin To cMax
                        varSwap(c) = pvarArray(i, c)
                    Next
                    lngHold = i
                    Do While pvarArray(lngHold - lngGap, plngCol) > varSwap(plngCol)
                        For c = cMin To cMax
                            pvarArray(lngHold, c) = pvarArray(lngHold - lngGap, c)
                        Next
                        lngHold = lngHold - lngGap
                        If lngHold < lngGap + iMin Then Exit Do
                    Loop
                    For c = cMin To cMax
                        pvarArray(lngHold, c) = varSwap(c)
                    Next
                Next i
            Loop Until lngGap = 1
    End Select
End Sub

Public Function VerifySort2(ByRef pvarArray As Variant, plngDim As Long, plngCol As Long) As Boolean
    Dim i As Long
    
    VerifySort2 = True
    Select Case plngDim
        Case 1
            For i = LBound(pvarArray, 2) To UBound(pvarArray, 2) - 1
                If pvarArray(plngCol, i) > pvarArray(plngCol, i + 1) Then
                    VerifySort2 = False
                    Exit For
                End If
            Next
        Case 2
            For i = LBound(pvarArray, 1) To UBound(pvarArray, 1) - 1
                If pvarArray(i, plngCol) > pvarArray(i + 1, plngCol) Then
                    VerifySort2 = False
                    Exit For
                End If
            Next
    End Select
End Function

